#include once "windows.bi"
#include once "win\mmsystem.bi"


Declare Sub OpenMIDI()
Declare Sub CloseMIDI()
Declare Sub SendMidiOut(ByVal midiData1 As Integer, ByVal midiData2 As Integer, _
                        ByVal midiMessageOut As Integer, ByVal Kanal As Integer)
Declare Sub Silence()
Declare Sub Play(ByVal Melody As String, ByVal Stimme As Integer = 16, _
 ByVal Octave As Integer = 5, ByVal Laut As Integer = 100, ByVal Dauer As Integer = 200)


Const NOTE_OFF = &H80
Const NOTE_ON = &H90
Const PROGRAM_CHANGE = &HC0
Dim Shared hMidiOut As HMIDIOUT

Sub OpenMIDI()
  Dim midiOpenError As Integer
  Dim strMsg As String

  midiOpenError = midiOutOpen( @hMidiOut, MIDI_MAPPER, 0, 0, CALLBACK_NULL)

  If midiOpenError Then
    strMsg = "Der MIDI Mapper kann nicht geffnet werden. "
    strMsg = strMsg + "Er wird entweder bereits verwendet oder "
    strMsg = strMsg + "ist nicht korrekt installiert." + Chr(13,11)
    strMsg = strMsg + "Fehler " + Str(midiOpenError)
    MessageBox null,strMsg, "PLAY by -=I3I2UI/I0=-",MB_ICONERROR
    CloseMIDI
    '? strMsg
    End
  End If
End Sub

Sub CloseMIDI()
  midiOutClose hMidiOut
  hMidiOut = 0
End Sub

Sub SendMidiOut(ByVal midiData1 As Integer, ByVal midiData2 As Integer, _
                ByVal midiMessageOut As Integer, ByVal Kanal As Integer)
  Dim miMsg As Integer, Erg As Integer

  miMsg = Kanal + midiMessageOut + (midiData1 * &H100) + (midiData2 * &H10000)
  Erg = midiOutShortMsg(hMidiOut, miMsg)
End Sub

Sub Silence()
  midiOutReset hMidiOut
End Sub

Sub Play (ByVal Melody As String, _
          ByVal Stimme As Integer, _
          ByVal Octave As Integer, _
          ByVal Laut As Integer, _
          ByVal Dauer As Integer)
  Dim Tempo As Integer, Pause As Integer, Ton As Integer
  Dim ReClose As Integer, i As Integer, j As Integer
  Dim sM As String, sM1 As String, sM2 As String, sM3 As String
  Dim TFak As Single, t As Single

  On Error GoTo playErrHandle

  If hMidiOut = 0 Then
   OpenMIDI
   ReClose = 1
  End If

  If Stimme >= 0 Then
    SendMidiOut Stimme, 0, PROGRAM_CHANGE, 0
  End If
    Tempo = 128
    Pause = 0
    TFak = 1
  For i = 1 To Len(Melody)
     sM = Mid(Melody, i, 1)
    sM1 = Mid(Melody, i + 1, 1)
    sM2 = Mid(Melody, i + 2, 1)
    sM3 = Mid(Melody, i + 3, 1)
    Ton = -1

    Select Case UCase(sM)
      Case "A" : Ton = 9
      Case "B", "H" : Ton = 11
      Case "C" : Ton = 0
      Case "D" : Ton = 2
      Case "E" : Ton = 4
      Case "F" : Ton = 5
      Case "G" : Ton = 7

      Case "I"
       j = Val(sM1+sM2+sM3)
       i += 1
       If j > 9 Then 
        i += 1
        If j > 99 Then 
         i += 1
        End If
       End If
       If j > 0 And j < 128 Then SendMidiOut j, 0, PROGRAM_CHANGE, 0       

      Case "L"
        TFak = Val(sM1+sM2)     ' 1/1,1/2,1/4,1/8 Note
        i += 1        
        If TFak > 9 Then i += 1
        TFak = 1/TFak

      Case "M" 'Keine Auswirkung ; do nothing
       Select Case UCase(sM1)
        Case "F": i += 1    ' wartet bis Musik gespielt wurde
        Case "B": i += 1    ' die Musik im Hintergrund
        Case "N": i += 1    ' normale spielweise 7/8 Tonlnge
        Case "L": i += 1    ' legato
        Case "S": i += 1    ' staccato 3/4 Tonlnge      
       End Select

      Case "N"        
        j = Val(sM1+sM2)
        i += 1        
        If j > 9 Then i += 1
        Octave = (j\12)
        Ton= j Mod 12       

      Case "O"        
        Octave = Val(sM1)+3
        i += 1

      Case "P"        
        Pause = Val(sM1+sM2)
        i += 1        
        If Pause > 9 Then i += 1

      Case "T"         ' Setzt das Tempo auf xxx Viertelnoten in einer Minute
        Tempo = 0
        If Val(sM1)>0 Then 
         Tempo = Val(sM1+sM2+sM3)
         i += 1
         If Tempo > 9 Then 
          i += 1
          If Tempo > 99 Then 
           i += 1
          End If
         End If
        End If
        If Tempo=0 Then Tempo = 128

      Case ">" : Octave += 1  'erhht die momentane Oktave +1
      Case "<" : Octave -= 1  'erniedrigt die momentane Oktave -1
    End Select

    Dauer = 240000 \ Tempo
    If Pause > 0 Then Pause = Dauer/Pause
    t = TFak
    If ton > -1 Then 'dann Ton spielen 
      Select Case UCase(sM1)
       Case "1" To "9"     ' 1/1, 1/2, 1/4, 1/8 Note
        j = Val(sM1+sM2)
        i += 1        
        If j > 9 Then i += 1
        sM = Mid(Melody, i, 1)
        If sM = "." Then 
         i += 1
         t = t+1/j
        Else
         t= 1/j
        End If 
       Case "."   ' der Punkt verlngert Dauer der Note um ihren halben Wert
        t = t*1.5
        i += 1
       Case "#","+"     ' spielt die Note um einen Halbton hher
        Ton += 1
        i += 1
       Case "-"         ' spielt die Note um einen Halbton niedriger
        Ton -= 1
        i += 1
      End Select

     SendMidiOut Ton + 12 * Octave, Laut, NOTE_ON, 0
     Sleep (Dauer*t)+Pause
     Pause = 0
     SendMidiOut Ton + 12 * Octave, Laut, NOTE_OFF, 0
    End If 

  Next i

  If ReClose Then CloseMIDI 
  Exit Sub

playErrHandle:
 'MessageBox null,"Es liegt ein Syntaxfehler bei der Eingabe des Tones vor!"_
 '+Melody,"PLAY by -=I3I2UI/I0=-",MB_ICONERROR
 'sleep
 Silence 
End Sub
